# Building OpenCV for VOXL


OpenCV is distributed for VOXL through the opkg package repo:

voxl-packages.modalai.com

It is installed as part of voxl-suite and should not need to be compiled from source unless you are trying something custom. For details on building older versions of opencv for 32-bit see the README.md file in the legacy folders


## Build Instructions

0) Get the source code (including submodules)
```
git clone --recursive https://gitlab.com/voxl-public/voxl-sdk/third-party/voxl-opencv.git -b master
```

 
1) Prerequisite: the voxl-cross docker image >= V1.7

Follow the instructions here to build and install the voxl-cross docker image:

https://gitlab.com/voxl-public/voxl-docker


2) Launch the voxl-cross docker.

```bash
~/git/voxl-opencv$ voxl-docker -i voxl-cross
voxl-cross:~$
```

3) Build for either `qrb5165` or `apq8096`. CI will pass these arguments to the build script based on the job target. The build script in this template will build a multi-arch package with binaries for both 64 and 32 bit.

```bash
voxl-cross:~$ ./build.sh qrb5165
OR
voxl-cross:~$ ./build.sh apq8096
```


4) Make an ipk or deb package while still inside the docker.

```bash
voxl-cross:~$ ./make_package.sh deb
OR
voxl-cross:~$ ./make_package.sh ipk
```

This will make a new package file in your working directory. The name and version number came from the package control file. If you are updating the package version, edit it there.

Optionally add the --timestamp argument to append the current data and time to the package version number in the debian package. This is done automatically by the CI package builder for development and nightly builds, however you can use it yourself if you like.


## Deploy to VOXL

You can now push the ipk or deb package to VOXL and install with dpkg/opkg however you like. To do this over ADB, you may use the included helper script: deploy_to_voxl.sh. Do this outside of docker as your docker image probably doesn't have usb permissions for ADB.

The deploy_to_voxl.sh script will query VOXL over adb to see if it has dpkg installed. If it does then then .deb package will be pushed an installed. Otherwise the .ipk package will be installed with opkg.

```bash
(outside of docker)
voxl-opencv$ ./deploy_to_voxl.sh
```

This deploy script can also push over a network given sshpass is installed and the VOXL uses the default root password.


```bash
(outside of docker)
voxl-opencv$ ./deploy_to_voxl.sh ssh 192.168.1.123
```

### Note
When developing on the VOXL Emulator or on target, it may be necessary uninstall OpenCV 2.4 first. These are the commands to remove the old OpenCV 2.4:

```
opkg remove lib32-opencv --force-removal-of-dependent-packages
opkg remove lib32-libopencv --force-removal-of-dependent-packages
opkg remove lib32-libopencv-core2.4 --force-removal-of-dependent-packages
opkg remove lib32-opencv-dbg --force-removal-of-dependent-packages
```

